
/* 
 * This file is part of the RTL examples distribution (https://tealsemi.com).
 * Copyright (c) 2022 Franz Steininger.
 * 
 * This program is free software: you can redistribute it and/or modify  
 * it under the terms of the GNU General Public License as published by  
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

`default_nettype none

module test_must (
  input  wire signed [15:0] a,   // input term1 (real part)
  input  wire signed [15:0] b,   // input term1 (imaginary part)
  input  wire signed [15:0] c,   // input term2 (real part)
  input  wire signed [15:0] d,   // input term2 (imaginary part)
  output wire signed [32:0] x,   // result of product (real part)
  output wire signed [32:0] y    // result of product (imaginary part)
);

/* behavioral code: (a+bi) * (c+di) = (ac−bd) + (ad+bc)i */

assign x = a * c - b * d;
assign y = a * d + b * c;

endmodule

`default_nettype wire


